Index: zaptel.xml
===================================================================
--- zaptel.xml	(revision 2381)
+++ zaptel.xml	(working copy)
@@ -1,61 +1,61 @@
 <category name="MENUSELECT_MODULES" displayname="Kernel Modules">
-	<member name="pciradio" displayname="PCI Radio" remove_on_change="pciradio.o pciradio.ko">
+	<member name="pciradio" displayname="PCI Quad Radio Interface Driver" remove_on_change="pciradio.o pciradio.ko">
 	</member>
-	<member name="tor2" displayname="Tormenta 2" remove_on_change="tor2.o tor2.ko">
+	<member name="tor2" displayname="Tormenta 2 Quad-T1 PCI Driver" remove_on_change="tor2.o tor2.ko">
 	</member>
-	<member name="torisa" displayname="Tormenta ISA" remove_on_change="torisa.o torisa.ko">
+	<member name="torisa" displayname="Old Tormenta 1 ISA Card Driver" remove_on_change="torisa.o torisa.ko">
 	</member>
-	<member name="wcfxo" displayname="Wildcard X100P" remove_on_change="wcfxo.o wcfxo.ko">
+	<member name="wcfxo" displayname="Wilcard X100P FXO Interface Driver" remove_on_change="wcfxo.o wcfxo.ko">
 	</member>
-	<member name="wct1xxp" displayname="Wildcard T100P / E100P" remove_on_change="wct1xxp.o wct1xxp.ko">
+	<member name="wct1xxp" displayname="Wildcard T100P/E100P T1/PRI Card Driver" remove_on_change="wct1xxp.o wct1xxp.ko">
 	</member>
-	<member name="wct4xxp" displayname="Wildcard TE4XXP / TE2XXP" remove_on_change="wct4xxp.o wct4xxp.ko">
+	<member name="wct4xxp" displayname="Wilcard TE4XXP/TE2XXP FXS Interface Driver" remove_on_change="wct4xxp.o wct4xxp.ko">
 	</member>
-	<member name="wctdm" displayname="Wildcard TDM400P" remove_on_change="wctdm.o wctdm.ko">
+	<member name="wctdm" displayname="Wilcard TDM400P TDM FXS/FXO Interface Driver" remove_on_change="wctdm.o wctdm.ko">
 	</member>
-	<member name="wctdm24xxp" displayname="Wildcard TDM2400P" remove_on_change="wctdm24xxp.o wctdm24xxp.ko">
+	<member name="wctdm24xxp" displayname="Wilcard TDM2400P TDM FXS/FXO Interface Driver" remove_on_change="wctdm24xxp.o wctdm24xxp.ko">
 	</member>
-	<member name="wcte11xp" displayname="Wildcard TE110P" remove_on_change="wcte11xp.o wcte11xp.ko">
+	<member name="wcte11xp" displayname="Wildcard TE110P T1/PRI Card Driver" remove_on_change="wcte11xp.o wcte11xp.ko">
 	</member>
-	<member name="wcusb" displayname="Wildcard S100U" remove_on_change="wcusb.o wcusb.ko">
+	<member name="wcusb" displayname="Wildcard S100U USB FXS Interface Driver" remove_on_change="wcusb.o wcusb.ko">
 	</member>
-	<member name="xpp_usb" displayname="Astribank">
+	<member name="xpp_usb" displayname="Xorcom's Astribank Driver">
 	</member>
-	<member name="zaptel" displayname="Zaptel" remove_on_change="zaptel.o zaptel.ko">
+	<member name="zaptel" displayname="Zapata Telephony Interface Driver" remove_on_change="zaptel.o zaptel.ko">
 	</member>
-	<member name="ztd-eth" displayname="TDMoE" remove_on_change="ztd-eth.o ztd-eth.ko">
+	<member name="ztd-eth" displayname="TDMoE Interface for Zaptel" remove_on_change="ztd-eth.o ztd-eth.ko">
 	</member>
-	<member name="ztd-loc" displayname="Local" remove_on_change="ztd-loc.o ztd-loc.ko">
+	<member name="ztd-loc" displayname="Local Interface for Zaptel" remove_on_change="ztd-loc.o ztd-loc.ko">
 	</member>
 	<member name="ztdummy" displayname="Dummy Timing Interface" remove_on_change="ztdummy.o ztdummy.ko">
 	</member>
-	<member name="ztdynamic" displayname="Dynamic" remove_on_change="ztdynamic.o ztdynamic.ko">
+	<member name="ztdynamic" displayname="Dynamic Span (TDMoX) Driver" remove_on_change="ztdynamic.o ztdynamic.ko">
 	</member>
-	<member name="zttranscode" displayname="Zaptel Transcoders" remove_on_change="zttranscode.o zttranscode.ko">
+	<member name="zttranscode" displayname="Zaptel Transcoders Support" remove_on_change="zttranscode.o zttranscode.ko">
 	</member>
 </category>
 
 <category name="MENUSELECT_UTILS" displayname="Utilities">
-	<member name="fxotune" remove_on_change="fxotune fxotune.o">
+	<member name="fxotune" displayname="Automatic tuner for FXO channels on a TDM400 card" remove_on_change="fxotune fxotune.o">
 	</member>
-	<member name="fxstest" remove_on_change="fxstest fxstest.o">
+	<member name="fxstest" displayname="Generic tester for FXS channels" remove_on_change="fxstest fxstest.o">
 		<defaultenabled>no</defaultenabled>
 	</member>
-	<member name="sethdlc-new" remove_on_change="sethdlc-new sethdlc-new.o">
+	<member name="sethdlc-new" displayname="Utility to set HDLC modes for Zaptel" remove_on_change="sethdlc-new sethdlc-new.o">
 		<defaultenabled>no</defaultenabled>
 	</member>
-	<member name="ztcfg" remove_on_change="ztcfg ztcfg.o">
+	<member name="ztcfg" displayname="Utility to configure Zaptel Interface Cards" remove_on_change="ztcfg ztcfg.o">
 	</member>
-	<member name="ztdiag" remove_on_change="ztdiag ztdiag.o">
+	<member name="ztdiag" displayname="Utility to dump information from a Zaptel channel" remove_on_change="ztdiag ztdiag.o">
 		<defaultenabled>no</defaultenabled>
 	</member>
-	<member name="ztmonitor" remove_on_change="ztmonitor ztmonitor.o">
+	<member name="ztmonitor" displayname="Utility that checks RX/TX levels of the Zaptel intefaces" remove_on_change="ztmonitor ztmonitor.o">
 	</member>
-	<member name="ztspeed" remove_on_change="ztspeed ztspeed.o">
+	<member name="ztspeed" displayname="A generic speed and CPU tester for Zaptel interfaces" remove_on_change="ztspeed ztspeed.o">
 	</member>
-	<member name="zttest" remove_on_change="zttest zttest.o">
+	<member name="zttest" displayname="Test if the Zaptel Timer provides timely response" remove_on_change="zttest zttest.o">
 	</member>
-	<member name="zttool" remove_on_change="zttool zttool.o">
+	<member name="zttool" displayname="Utility to show the status of an interface card" remove_on_change="zttool zttool.o">
 		<depend>libnewt</depend>
 	</member>
 </category>