Index: build_tools/embed_modules.xml
===================================================================
--- build_tools/embed_modules.xml	(revision 60318)
+++ build_tools/embed_modules.xml	(working copy)
@@ -1,26 +1,26 @@
 	<category name="MENUSELECT_EMBED" displayname="Module Embedding" positive_output="yes" remove_on_change="main/asterisk">
-		<member name="apps" displayname="Applications" remove_on_change="apps/*.o">
+		<member name="apps" displayname="Application modules" remove_on_change="apps/*.o">
 			<depend>gnu_ld</depend>
 		</member>
-		<member name="cdr" displayname="Call Detail Recording" remove_on_change="cdr/*.o">
+		<member name="cdr" displayname="Call Detail Recording modules" remove_on_change="cdr/*.o">
 			<depend>gnu_ld</depend>
 		</member>
-		<member name="channels" displayname="Channels" remove_on_change="channels/*.o channels/misdn/*.o">
+		<member name="channels" displayname="Channel modules" remove_on_change="channels/*.o channels/misdn/*.o">
 			<depend>gnu_ld</depend>
 		</member>
-		<member name="codecs" displayname="Coders/Decoders" remove_on_change="codecs/*.o codecs/gsm/src/*.o codecs/ilbc/*.o codecs/lpc10/*.o codecs/gsm/lib/libgsm.a codecs/lpc10/liblpc10.a codecs/ilbc/libilbc.a codecs/g722/libg722.a">
+		<member name="codecs" displayname="Coder/Decoder modules" remove_on_change="codecs/*.o codecs/gsm/src/*.o codecs/ilbc/*.o codecs/lpc10/*.o codecs/gsm/lib/libgsm.a codecs/lpc10/liblpc10.a codecs/ilbc/libilbc.a codecs/g722/libg722.a">
 			<depend>gnu_ld</depend>
 		</member>
-		<member name="formats" displayname="File Formats" remove_on_change="formats/*.o">
+		<member name="formats" displayname="File format modules" remove_on_change="formats/*.o">
 			<depend>gnu_ld</depend>
 		</member>
-		<member name="funcs" displayname="Dialplan Functions" remove_on_change="funcs/*.o">
+		<member name="funcs" displayname="Dialplan function modules" remove_on_change="funcs/*.o">
 			<depend>gnu_ld</depend>
 		</member>
-		<member name="pbx" displayname="PBX Functionality" remove_on_change="pbx/*.o pbx/ael/*.o">
+		<member name="pbx" displayname="Core PBX modules" remove_on_change="pbx/*.o pbx/ael/*.o">
 			<depend>gnu_ld</depend>
 		</member>
-		<member name="res" displayname="Resource Modules" remove_on_change="res/*.o res/snmp/*.o">
+		<member name="res" displayname="Resource modules" remove_on_change="res/*.o res/snmp/*.o">
 			<depend>gnu_ld</depend>
 		</member>
 	</category>
Index: pbx/pbx_loopback.c
===================================================================
--- pbx/pbx_loopback.c	(revision 60318)
+++ pbx/pbx_loopback.c	(working copy)
@@ -180,4 +180,4 @@
 	return 0;
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Loopback Switch");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Loopback dialplan switch support");
Index: pbx/pbx_realtime.c
===================================================================
--- pbx/pbx_realtime.c	(revision 60318)
+++ pbx/pbx_realtime.c	(working copy)
@@ -253,4 +253,4 @@
 	return 0;
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Realtime Switch");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Realtime dialplan switch (using a database)");
Index: channels/chan_jingle.c
===================================================================
--- channels/chan_jingle.c	(revision 60318)
+++ channels/chan_jingle.c	(working copy)
@@ -1738,7 +1738,7 @@
 	return 0;
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, "Jingle Channel Driver",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, "Jingle channel driver to the Jabber/XMPP extension",
 		.load = load_module,
 		.unload = unload_module,
 		.reload = reload,
Index: channels/chan_zap.c
===================================================================
--- channels/chan_zap.c	(revision 60318)
+++ channels/chan_zap.c	(working copy)
@@ -12913,9 +12913,9 @@
  */
 
 #ifdef ZAPATA_PRI
-#define tdesc "Zapata Telephony w/PRI"
+#define tdesc "Zapata Telephony channel driver with PRI support"
 #else
-#define tdesc "Zapata Telephony"
+#define tdesc "Zapata Telephony channel driver"
 #endif
 
 AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, tdesc,
Index: channels/chan_vpb.cc
===================================================================
--- channels/chan_vpb.cc	(revision 60318)
+++ channels/chan_vpb.cc	(working copy)
@@ -3049,4 +3049,8 @@
 #endif
 /**/
 
-
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, "VoiceTronix API driver (for V6PCI/V12PCI/V4PCI)",
+		.load = load_module,
+		.unload = unload_module,
+		.reload = reload,
+	       );
Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 60318)
+++ channels/chan_sip.c	(working copy)
@@ -18275,7 +18275,7 @@
 	return 0;
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, "Session Initiation Protocol (SIP)",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, "Session Initiation Protocol (SIP) channels support",
 		.load = load_module,
 		.unload = unload_module,
 		.reload = reload,
Index: apps/app_zapras.c
===================================================================
--- apps/app_zapras.c	(revision 60318)
+++ apps/app_zapras.c	(working copy)
@@ -256,5 +256,5 @@
 	return ast_register_application(app, zapras_exec, synopsis, descrip);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Zap RAS Application");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Executes a Zaptel ISDN RAS application");
 
Index: apps/app_stack.c
===================================================================
--- apps/app_stack.c	(revision 60318)
+++ apps/app_stack.c	(working copy)
@@ -338,4 +338,4 @@
 	return 0;
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Stack Routines");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Stack dialplan routines (GoSub, Return, etc)");
Index: apps/app_morsecode.c
===================================================================
--- apps/app_morsecode.c	(revision 60318)
+++ apps/app_morsecode.c	(working copy)
@@ -175,4 +175,4 @@
 	return ast_register_application(app_morsecode, morsecode_exec, morsecode_synopsis, morsecode_descrip);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Morse code");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Playback application for morse codes");
Index: apps/app_channelredirect.c
===================================================================
--- apps/app_channelredirect.c	(revision 60318)
+++ apps/app_channelredirect.c	(working copy)
@@ -137,4 +137,4 @@
 	return ast_register_application(app, asyncgoto_exec, synopsis, descrip);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Channel Redirect");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Application to redirect channels to a dialplan target");
Index: apps/app_sms.c
===================================================================
--- apps/app_sms.c	(revision 60318)
+++ apps/app_sms.c	(working copy)
@@ -1950,4 +1950,4 @@
 	return ast_register_application (app, sms_exec, synopsis, descrip);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "SMS/PSTN handler");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "SMS/PSTN handler application");
Index: apps/app_waitforsilence.c
===================================================================
--- apps/app_waitforsilence.c	(revision 60318)
+++ apps/app_waitforsilence.c	(working copy)
@@ -203,5 +203,5 @@
 	return ast_register_application(app, waitforsilence_exec, synopsis, descrip);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Wait For Silence");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Waits for up to 'x' milliseconds of silence");
 
Index: apps/app_sayunixtime.c
===================================================================
--- apps/app_sayunixtime.c	(revision 60318)
+++ apps/app_sayunixtime.c	(working copy)
@@ -123,4 +123,4 @@
 	return res;
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Say time");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Says a specified time in a custom format and timezone");
Index: apps/app_transfer.c
===================================================================
--- apps/app_transfer.c	(revision 60318)
+++ apps/app_transfer.c	(working copy)
@@ -153,4 +153,4 @@
 	return ast_register_application(app, transfer_exec, synopsis, descrip);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Transfer");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Application to transfer a caller to a remote extension");
Index: funcs/func_base64.c
===================================================================
--- funcs/func_base64.c	(revision 60318)
+++ funcs/func_base64.c	(working copy)
@@ -92,4 +92,4 @@
 		ast_custom_function_register(&base64_decode_function);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "base64 encode/decode dialplan functions");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Base64 encode/decode dialplan functions");
Index: funcs/func_enum.c
===================================================================
--- funcs/func_enum.c	(revision 60318)
+++ funcs/func_enum.c	(working copy)
@@ -197,4 +197,4 @@
 	return res;
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "ENUM related dialplan functions");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "ENUM related functions (to query NAPTR or DNS records)");
Index: funcs/func_curl.c
===================================================================
--- funcs/func_curl.c	(revision 60318)
+++ funcs/func_curl.c	(working copy)
@@ -208,5 +208,5 @@
 	return res;
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Load external URL");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Retrieves the contents of an URL through the CURL library");
 
Index: funcs/func_odbc.c
===================================================================
--- funcs/func_odbc.c	(revision 60318)
+++ funcs/func_odbc.c	(working copy)
@@ -669,7 +669,7 @@
 
 /* XXX need to revise usecount - set if query_lock is set */
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, "ODBC lookups",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, "ODBC lookups support in dialplan using UnixODBC driver",
 		.load = load_module,
 		.unload = unload_module,
 		.reload = reload,
Index: funcs/func_shell.c
===================================================================
--- funcs/func_shell.c	(revision 60318)
+++ funcs/func_shell.c	(working copy)
@@ -88,5 +88,5 @@
 	return ast_custom_function_register(&shell_function);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "SHELL dialplan function");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Function to return the value of a system call");
 
Index: funcs/func_cdr.c
===================================================================
--- funcs/func_cdr.c	(revision 60318)
+++ funcs/func_cdr.c	(working copy)
@@ -165,4 +165,4 @@
 	return ast_custom_function_register(&cdr_function);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "CDR dialplan function");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Call Detail Record (CDR) dialplan function");
Index: funcs/func_devstate.c
===================================================================
--- funcs/func_devstate.c	(revision 60318)
+++ funcs/func_devstate.c	(working copy)
@@ -202,4 +202,4 @@
 	return res;
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Device state dialplan functions");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Function to get or set a device state in the dialplan");
Index: res/res_config_sqlite.c
===================================================================
--- res/res_config_sqlite.c	(revision 60318)
+++ res/res_config_sqlite.c	(working copy)
@@ -1305,7 +1305,7 @@
 	return 0;
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "SQLite Configuration",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "SQLite configuration driver",
 		.load = load_module,
 		.unload = unload_module,
 );
Index: res/res_config_odbc.c
===================================================================
--- res/res_config_odbc.c	(revision 60318)
+++ res/res_config_odbc.c	(working copy)
@@ -592,7 +592,7 @@
 	return 0;
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "ODBC Configuration",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "ODBC configuration driver",
 		.load = load_module,
 		.unload = unload_module,
 		);
Index: res/res_indications.c
===================================================================
--- res/res_indications.c	(revision 60318)
+++ res/res_indications.c	(working copy)
@@ -394,7 +394,7 @@
 	return ind_load_module();
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "Indications Resource",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "Country specific dialtones support",
 		.load = load_module,
 		.unload = unload_module,
 		.reload = reload,
Index: res/res_odbc.c
===================================================================
--- res/res_odbc.c	(revision 60318)
+++ res/res_odbc.c	(working copy)
@@ -686,7 +686,7 @@
 	return 0;
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "ODBC Resource",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "ODBC resource support",
 		.load = load_module,
 		.unload = unload_module,
 		.reload = reload,
Index: res/res_limit.c
===================================================================
--- res/res_limit.c	(revision 60318)
+++ res/res_limit.c	(working copy)
@@ -179,5 +179,5 @@
 	return ast_cli_register(&cli_ulimit)? AST_MODULE_LOAD_FAILURE: AST_MODULE_LOAD_SUCCESS;
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Resource limits");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Resources limitation support using ulimit");
 
Index: res/res_adsi.c
===================================================================
--- res/res_adsi.c	(revision 60318)
+++ res/res_adsi.c	(working copy)
@@ -1144,7 +1144,7 @@
 	return -1;
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "ADSI Resource",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "ADSI resource support",
 		.load = load_module,
 		.unload = unload_module,
 		.reload = reload,