Index: channels/chan_vpb.cc
===================================================================
--- channels/chan_vpb.cc	(revision 60479)
+++ channels/chan_vpb.cc	(working copy)
@@ -3049,4 +3049,8 @@
 #endif
 /**/
 
-
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, "VoiceTronix API driver",
+		.load = load_module,
+		.unload = unload_module,
+		.reload = reload,
+	       );
Index: apps/app_zapras.c
===================================================================
--- apps/app_zapras.c	(revision 60479)
+++ apps/app_zapras.c	(working copy)
@@ -256,5 +256,5 @@
 	return ast_register_application(app, zapras_exec, synopsis, descrip);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Zap RAS Application");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Zaptel ISDN Remote Access Server");
 
Index: apps/app_stack.c
===================================================================
--- apps/app_stack.c	(revision 60479)
+++ apps/app_stack.c	(working copy)
@@ -338,4 +338,4 @@
 	return 0;
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Stack Routines");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Dialplan subroutines (Gosub, Return, etc)");
Index: apps/app_channelredirect.c
===================================================================
--- apps/app_channelredirect.c	(revision 60479)
+++ apps/app_channelredirect.c	(working copy)
@@ -137,4 +137,4 @@
 	return ast_register_application(app, asyncgoto_exec, synopsis, descrip);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Channel Redirect");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Redirects a given channel to a dialplan target");
Index: apps/app_transfer.c
===================================================================
--- apps/app_transfer.c	(revision 60479)
+++ apps/app_transfer.c	(working copy)
@@ -153,4 +153,4 @@
 	return ast_register_application(app, transfer_exec, synopsis, descrip);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Transfer");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Transfers a caller to another extension");
Index: funcs/func_shell.c
===================================================================
--- funcs/func_shell.c	(revision 60479)
+++ funcs/func_shell.c	(working copy)
@@ -88,5 +88,5 @@
 	return ast_custom_function_register(&shell_function);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "SHELL dialplan function");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Returns the output of a shell command");
 
Index: funcs/func_cdr.c
===================================================================
--- funcs/func_cdr.c	(revision 60479)
+++ funcs/func_cdr.c	(working copy)
@@ -165,4 +165,4 @@
 	return ast_custom_function_register(&cdr_function);
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "CDR dialplan function");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Call Detail Record (CDR) dialplan function");
Index: funcs/func_devstate.c
===================================================================
--- funcs/func_devstate.c	(revision 60479)
+++ funcs/func_devstate.c	(working copy)
@@ -202,4 +202,4 @@
 	return res;
 }
 
-AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Device state dialplan functions");
+AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Gets or sets a device state in the dialplan");
Index: res/res_config_sqlite.c
===================================================================
--- res/res_config_sqlite.c	(revision 60479)
+++ res/res_config_sqlite.c	(working copy)
@@ -1305,7 +1305,7 @@
 	return 0;
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "SQLite Configuration",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "Realtime SQLite configuration",
 		.load = load_module,
 		.unload = unload_module,
 );
Index: res/res_config_odbc.c
===================================================================
--- res/res_config_odbc.c	(revision 60479)
+++ res/res_config_odbc.c	(working copy)
@@ -592,7 +592,7 @@
 	return 0;
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "ODBC Configuration",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "Realtime ODBC configuration",
 		.load = load_module,
 		.unload = unload_module,
 		);
Index: res/res_indications.c
===================================================================
--- res/res_indications.c	(revision 60479)
+++ res/res_indications.c	(working copy)
@@ -394,7 +394,7 @@
 	return ind_load_module();
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "Indications Resource",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "Region-specific tones",
 		.load = load_module,
 		.unload = unload_module,
 		.reload = reload,
Index: res/res_odbc.c
===================================================================
--- res/res_odbc.c	(revision 60479)
+++ res/res_odbc.c	(working copy)
@@ -686,7 +686,7 @@
 	return 0;
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "ODBC Resource",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "ODBC resource",
 		.load = load_module,
 		.unload = unload_module,
 		.reload = reload,
Index: res/res_adsi.c
===================================================================
--- res/res_adsi.c	(revision 60479)
+++ res/res_adsi.c	(working copy)
@@ -1144,7 +1144,7 @@
 	return -1;
 }
 
-AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "ADSI Resource",
+AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_GLOBAL_SYMBOLS, "ADSI resource",
 		.load = load_module,
 		.unload = unload_module,
 		.reload = reload,